# This script replaces plugins with symlinks
# It goes into a folder that is first argument of the script
# Then into plugins, and then symlinks 

# SCL java dir is different from default

set -e

SCL_JAVA_DIRS=${@:2}

function _symlink {
	_f=$(ls | grep -e "^$1" || :)
	if [ -n "$_f" ] ; then
		rm -rf $_f
    echo $SCL_JAVA_DIRS
		for SCL_JAVA_DIR in ${SCL_JAVA_DIRS}; do
			if [ -f ${SCL_JAVA_DIR}/$2  ]; then
				echo "found ${SCL_JAVA_DIR}/$2"
				ln -s ${SCL_JAVA_DIR}/$2 ${_f%.jar}.jar
				return 0
			fi
		done
		echo "not found $2 in any of ${SCL_JAVA_DIRS}"
		exit 1
	fi
}

pushd $1
	# Remove and symlink all duplicate jars in the platform
	pushd plugins
    # _symlink org.eclipse.core.commands_ eclipse/org.eclipse.core.commands_*.jar
		_symlink org.eclipse.core.contenttype_ eclipse/core.contenttype.jar
		# _symlink org.eclipse.core.databinding_ eclipse/org.eclipse.core.databinding_*.jar
		# _symlink org.eclipse.core.databinding.beans_ eclipse/org.eclipse.core.databinding.beans_*.jar
		# _symlink org.eclipse.core.databinding.observable_ eclipse/org.eclipse.core.databinding.observable_*.jar
		# _symlink org.eclipse.core.databinding.property_ eclipse/org.eclipse.core.databinding.property_*.jar
		# _symlink org.eclipse.core.expressions_ eclipse/org.eclipse.core.expressions_*.jar
		# _symlink org.eclipse.core.filesystem_ eclipse/org.eclipse.core.filesystem_*.jar
		# _symlink org.eclipse.core.jobs_ eclipse/org.eclipse.core.jobs_*.jar
		# _symlink org.eclipse.core.net_ eclipse/org.eclipse.core.net_*.jar
		# _symlink org.eclipse.core.resources_ eclipse/org.eclipse.core.resources_*.jar
		# _symlink org.eclipse.core.runtime_ eclipse/org.eclipse.core.runtime_*.jar
		# _symlink org.eclipse.e4.core.commands_ eclipse/org.eclipse.e4.core.commands_*.jar
		# _symlink org.eclipse.e4.core.contexts_ eclipse/org.eclipse.e4.core.contexts_*.jar
		# _symlink org.eclipse.e4.core.di_ eclipse/org.eclipse.e4.core.di_*.jar
		# _symlink org.eclipse.e4.core.di.annotations_ eclipse/org.eclipse.e4.core.di.annotations_*.jar
		# _symlink org.eclipse.e4.core.di.extensions_ eclipse/org.eclipse.e4.core.di.extensions_*.jar
		# _symlink org.eclipse.e4.core.di.extensions.supplier_ eclipse/org.eclipse.e4.core.di.extensions.supplier_*.jar
		# _symlink org.eclipse.e4.core.services_ eclipse/org.eclipse.e4.core.services_*.jar
		# _symlink org.eclipse.e4.emf.xpath_ eclipse/org.eclipse.e4.emf.xpath_*.jar
		# _symlink org.eclipse.e4.ui.bindings_ eclipse/org.eclipse.e4.ui.bindings_*.jar
		# _symlink org.eclipse.e4.ui.css.core_ eclipse/org.eclipse.e4.ui.css.core_*.jar
		# _symlink org.eclipse.e4.ui.css.swt_ eclipse/org.eclipse.e4.ui.css.swt_*.jar
		# _symlink org.eclipse.e4.ui.css.swt.theme_ eclipse/org.eclipse.e4.ui.css.swt.theme_*.jar
		# _symlink org.eclipse.e4.ui.di_ eclipse/org.eclipse.e4.ui.di_*.jar
		# _symlink org.eclipse.e4.ui.dialogs_ eclipse/org.eclipse.e4.ui.dialogs_*.jar
		# _symlink org.eclipse.e4.ui.model.workbench_ eclipse/org.eclipse.e4.ui.model.workbench_*.jar
		# _symlink org.eclipse.e4.ui.services_ eclipse/org.eclipse.e4.ui.services_*.jar
		# _symlink org.eclipse.e4.ui.swt.gtk_ eclipse/org.eclipse.e4.ui.swt.gtk_*.jar
		# _symlink org.eclipse.e4.ui.widgets_ eclipse/org.eclipse.e4.ui.widgets_*.jar
		# _symlink org.eclipse.e4.ui.workbench_ eclipse/org.eclipse.e4.ui.workbench_*.jar
		# _symlink org.eclipse.e4.ui.workbench3_ eclipse/org.eclipse.e4.ui.workbench3_*.jar
		# _symlink org.eclipse.e4.ui.workbench.addons.swt_ eclipse/org.eclipse.e4.ui.workbench.addons.swt_*.jar
		# _symlink org.eclipse.e4.ui.workbench.renderers.swt_ eclipse/org.eclipse.e4.ui.workbench.renderers.swt_*.jar
		# _symlink org.eclipse.e4.ui.workbench.swt_ eclipse/org.eclipse.e4.ui.workbench.swt_*.jar
		_symlink org.eclipse.ecf_ eclipse/ecf.jar
		_symlink org.eclipse.ecf.filetransfer_ eclipse/ecf.filetransfer.jar
		_symlink org.eclipse.ecf.identity_ eclipse/ecf.identity.jar
		_symlink org.eclipse.ecf.provider.filetransfer_ eclipse/ecf.provider.filetransfer.jar
		_symlink org.eclipse.ecf.provider.filetransfer.httpclient4_ eclipse/ecf.provider.filetransfer.httpclient4.jar
		_symlink org.eclipse.ecf.provider.filetransfer.httpclient4.ssl_ eclipse/ecf.provider.filetransfer.httpclient4.ssl.jar
		_symlink org.eclipse.ecf.provider.filetransfer.ssl_ eclipse/ecf.provider.filetransfer.ssl.jar
		_symlink org.eclipse.ecf.ssl_ eclipse/ecf.ssl.jar
		_symlink org.eclipse.equinox.app_ eclipse/equinox.app.jar
		_symlink org.eclipse.equinox.bidi_ eclipse/equinox.bidi.jar
		_symlink org.eclipse.equinox.common_ eclipse/equinox.common.jar
		_symlink org.eclipse.equinox.concurrent_ eclipse/equinox.concurrent.jar
		_symlink org.eclipse.equinox.console_ eclipse/equinox.console.jar
		_symlink org.eclipse.equinox.ds_ eclipse/equinox.ds.jar
		_symlink org.eclipse.equinox.event_ eclipse/equinox.event.jar
		_symlink org.eclipse.equinox.frameworkadmin_ eclipse/equinox.frameworkadmin.jar
		_symlink org.eclipse.equinox.frameworkadmin.equinox_ eclipse/equinox.frameworkadmin.equinox.jar
		_symlink org.eclipse.equinox.http.jetty_ eclipse/equinox.http.jetty.jar
		_symlink org.eclipse.equinox.http.registry_ eclipse/equinox.http.registry.jar
		_symlink org.eclipse.equinox.jsp.jasper_ eclipse/equinox.jsp.jasper.jar
		_symlink org.eclipse.equinox.jsp.jasper.registry_ eclipse/equinox.jsp.jasper.registry.jar
		_symlink org.eclipse.equinox.launcher_ eclipse/equinox.launcher.jar
		# _symlink org.eclipse.equinox.launcher.gtk.linux.x86_ eclipse/org.eclipse.equinox.launcher.gtk.linux.x86_*.jar
		_symlink org.eclipse.equinox.p2.artifact.repository_ eclipse/equinox.p2.artifact.repository.jar
		_symlink org.eclipse.equinox.p2.console_ eclipse/equinox.p2.console.jar
		_symlink org.eclipse.equinox.p2.core_ eclipse/equinox.p2.core.jar
		_symlink org.eclipse.equinox.p2.director_ eclipse/equinox.p2.director.jar
		_symlink org.eclipse.equinox.p2.director.app_ eclipse/equinox.p2.director.app.jar
		_symlink org.eclipse.equinox.p2.directorywatcher_ eclipse/equinox.p2.directorywatcher.jar
		_symlink org.eclipse.equinox.p2.engine_ eclipse/equinox.p2.engine.jar
		_symlink org.eclipse.equinox.p2.extensionlocation_ eclipse/equinox.p2.extensionlocation.jar
		_symlink org.eclipse.equinox.p2.garbagecollector_ eclipse/equinox.p2.garbagecollector.jar
		_symlink org.eclipse.equinox.p2.jarprocessor_ eclipse/equinox.p2.jarprocessor.jar
		_symlink org.eclipse.equinox.p2.metadata_ eclipse/equinox.p2.metadata.jar
		_symlink org.eclipse.equinox.p2.metadata.repository_ eclipse/equinox.p2.metadata.repository.jar
		_symlink org.eclipse.equinox.p2.operations_ eclipse/equinox.p2.operations.jar
		_symlink org.eclipse.equinox.p2.publisher_ eclipse/equinox.p2.publisher.jar
		_symlink org.eclipse.equinox.p2.publisher.eclipse_ eclipse/equinox.p2.publisher.eclipse.jar
		_symlink org.eclipse.equinox.p2.reconciler.dropins_ eclipse/equinox.p2.reconciler.dropins.jar
		_symlink org.eclipse.equinox.p2.repository_ eclipse/equinox.p2.repository.jar
		_symlink org.eclipse.equinox.p2.touchpoint.eclipse_ eclipse/equinox.p2.touchpoint.eclipse.jar
		_symlink org.eclipse.equinox.p2.touchpoint.natives_ eclipse/equinox.p2.touchpoint.natives.jar
		_symlink org.eclipse.equinox.p2.transport.ecf_ eclipse/equinox.p2.transport.ecf.jar
		# _symlink org.eclipse.equinox.p2.ui_ eclipse/org.eclipse.equinox.p2.ui_*.jar
		# _symlink org.eclipse.equinox.p2.ui.sdk_ eclipse/org.eclipse.equinox.p2.ui.sdk_*.jar
		# _symlink org.eclipse.equinox.p2.ui.sdk.scheduler_ eclipse/org.eclipse.equinox.p2.ui.sdk.scheduler_*.jar
		# _symlink org.eclipse.equinox.p2.updatechecker_ eclipse/org.eclipse.equinox.p2.updatechecker_*.jar
		_symlink org.eclipse.equinox.preferences_ eclipse/equinox.preferences.jar
		_symlink org.eclipse.equinox.registry_ eclipse/equinox.registry.jar
		_symlink org.eclipse.equinox.security_ eclipse/equinox.security.jar
		# _symlink org.eclipse.equinox.security.linux.x86_64_ eclipse/org.eclipse.equinox.security.linux.x86_64_*.jar
		# _symlink org.eclipse.equinox.security.ui_ eclipse/org.eclipse.equinox.security.ui_*.jar
		_symlink org.eclipse.equinox.simpleconfigurator_ eclipse/equinox.simpleconfigurator.jar
		_symlink org.eclipse.equinox.simpleconfigurator.manipulator_ eclipse/equinox.simpleconfigurator.manipulator.jar
		_symlink org.eclipse.equinox.util_ eclipse/equinox.util.jar
		# _symlink org.eclipse.help_ eclipse/org.eclipse.help_*.jar
		# _symlink org.eclipse.help.base_ eclipse/org.eclipse.help.base_*.jar
		# _symlink org.eclipse.help.ui_ eclipse/org.eclipse.help.ui_*.jar
		# _symlink org.eclipse.help.webapp_ eclipse/org.eclipse.help.webapp_*.jar
		# _symlink org.eclipse.jdt.core.compiler.batch_ eclipse/org.eclipse.jdt.core.compiler.batch_*.jar
		# _symlink org.eclipse.jface_ eclipse/org.eclipse.jface_*.jar
		# _symlink org.eclipse.jface.databinding_ eclipse/org.eclipse.jface.databinding_*.jar
		# _symlink org.eclipse.jface.text_ eclipse/org.eclipse.jface.text_*.jar
		# _symlink org.eclipse.rcp_ eclipse/org.eclipse.rcp_*.jar
		# _symlink org.eclipse.swt.gtk.linux.x86_ eclipse/org.eclipse.swt.gtk.linux.x86_*.jar
		# _symlink org.eclipse.text_ eclipse/org.eclipse.text_*.jar
		# _symlink org.eclipse.ui_ eclipse/org.eclipse.ui_*.jar
		# _symlink org.eclipse.ui.forms_ eclipse/org.eclipse.ui.forms_*.jar
		# _symlink org.eclipse.ui.intro_ eclipse/org.eclipse.ui.intro_*.jar
		# _symlink org.eclipse.ui.net_ eclipse/org.eclipse.ui.net_*.jar
		# _symlink org.eclipse.ui.views_ eclipse/org.eclipse.ui.views_*.jar
		# _symlink org.eclipse.ui.workbench_ eclipse/org.eclipse.ui.workbench_*.jar
		# _symlink org.eclipse.update.configurator_ eclipse/org.eclipse.update.configurator_*.jar
	popd
popd

